/*
 * Created on 15-giu-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package scuola;

import java.security.InvalidParameterException;
import java.util.Enumeration;
import java.util.Hashtable;
import scuola.Exceptions.*;

/**
 * @author luigi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Materia {
	
	private String _nome;
	private String _descrizione;
	private Hashtable _professori;
	
	public Materia(String nome, String descrizione) {
		setNome(nome);
		setDescrizione(descrizione);
		_professori = new Hashtable();
	}
	
	public void setDescrizione(String descrizione) {
		_descrizione = descrizione;
	}
	
	public String getDescrizione() {
		return _descrizione;
	}
	
	private void setNome(String nome) {
		_nome = nome;
	}
	
	public String getNome() {
		return _nome;
	}
	
	public boolean equals(Object o) {
		if (o instanceof Materia) {
			return equals((Materia)o);
		}
		else {
			return false;
		}		
	}
	
	public boolean equals(Materia materia) {
		if (this.getNome()==materia.getNome()) {
			return true;
		}
		else {
			return false;
		}		
	}
	
	public String toString() {
		return getNome();
	}
	
	public boolean eInsegnataDalProfessore(int matricola) {
		Enumeration enum = _professori.elements();
		while (enum.hasMoreElements()) {
			Professore professore = (Professore)enum.nextElement();
			if (professore.getMatricola() == matricola) {
				return true;
			}
		}
		return false;
	}
	
	private boolean eInsegnataDalProfessore(Professore professore) {
		Integer iMatricola = new Integer(professore.getMatricola());
		return _professori.containsKey(iMatricola);
	}
	
	public void rimuoviProfessore(Professore professore) {
		rimuoviProfessore(professore.getMatricola());
	}
	
	public void rimuoviProfessore(int matricola) {
		if (!eInsegnataDalProfessore(matricola)) 
		{
			throw new ProfessoreNonTrovatoException("il professore con matricola " + matricola + " non risulta tra i professorei che insegnano: " + this.toString()); 
		}

		Integer iMatricola = new Integer(matricola);
		Professore professore = getProfessore(matricola);
		_professori.remove(iMatricola);
		try {
			professore.rimuoviMateria(this);
		}
		catch (MateriaNonTrovataException e) {
			
		}
	}	
	
	public Professore getProfessore(int matricola) {
		if (!eInsegnataDalProfessore(matricola)) {
			throw new ProfessoreNonTrovatoException("il professore con matricola " + matricola + " non risulta tra i professorei che insegnano : " + this.toString()); 
		}
		Integer iMatricola = new Integer(matricola);
		return (Professore)_professori.get(iMatricola);
	}
	
	public void aggiungiProfessore(Professore professore) {
		if (professore==null) {
			throw new InvalidParameterException("attenzione il professore non pu essere null");
		}
		if (eInsegnataDalProfessore(professore)) {
			throw new ProfessoreDuplicatoException("il professore con codice fiscale " + professore.getCodiceFiscale() + "  gi tra i professori che insegnano: " + this.toString()); 
		}
		
		Integer iMatricola = new Integer(professore.getMatricola());
		_professori.put(iMatricola,professore);
		try {
			professore.aggiungiMateria(this);
		}
		catch (MateriaDuplicataException e) {
			
		}
	}
	
	public Enumeration getProfessori() {
		return _professori.elements();
	}
	
	public int numeroDiProfessori() {
		return _professori.size();
	}
}
