/*
 * Created on 14-giu-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package scuola;

import java.security.InvalidParameterException;
import java.util.Date;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;

import scuola.Exceptions.*;

/**
 * @author luigi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Professore extends Persona {
	
	private int _matricola;
	private ArrayList _classi;
	Hashtable _materie;
	
	Professore(Persona persona, int matricola) {
		this(persona.getNome(), persona.getCognome(), persona.getDataNascita(), persona.getCodiceFiscale(), matricola);
	}
	
	Professore(String nome, String cognome, Date dataNascita, String codiceFiscale, int matricola) {
		super(nome, cognome, dataNascita, codiceFiscale);
		_matricola = matricola;
		_materie = new Hashtable();
		_classi = new ArrayList();
	}
	
	public int getMatricola() {
		return _matricola;
	}
	
	void setMatricola(int matricola) {
		_matricola = matricola;
	}
	
	public boolean insegna(Classe classe) {
		return _classi.contains(classe);
/*		Iterator iter = _classi.iterator();
		while (iter.hasNext()) {
			if (((Classe)iter.next()).equals(classe)) {
				return true;
			}
		}
		return false;
*/		
	}
	
	public void rimuoviClasse(Classe classe) {
		if (!insegna(classe)) 
		{
			throw new ClasseNonTrovataException("la classe " + classe + " non risulta tra quelle in cui insegna il profossore: " + this.toString()); 
		}
		_classi.remove(classe);
		try {
			classe.rimuoviProfessore(this);
		}
		catch (ProfessoreNonTrovatoException e) {
			
		}
	}	
	
	public void aggiungiClasse(Classe classe) {
		if (classe==null) {
			throw new InvalidParameterException("attenzione la classe non pu essere null");
		}
		if (insegna(classe)) {
			throw new ClasseDuplicataException("la classe " + classe + "  gi tra quelle in cui insegna il profossore: " + this.toString()); 
		}
		_classi.add(classe);
		
		try {
			classe.aggiungiProfessore(this);
		}
		catch (ProfessoreDuplicatoException e) {
			
		}
	}
	
	public int numeroDiClassi() {
		return _classi.size();
	}
	
	public boolean insegna(Materia materia) {
		return insegna(materia.getNome());
	}
	
	private boolean insegna(String materia) {
		return _materie.containsKey(materia);
	}
	
	public void rimuoviMateria(Materia materia) {
		rimuoviMateria(materia.getNome());
	}
	
	public void rimuoviMateria(String strMateria) {
		if (!insegna(strMateria)) 
		{
			throw new MateriaNonTrovataException("la materia " + strMateria + " non risulta tra quelle insegnate dal profossore: " + this.toString()); 
		}
		_materie.remove(strMateria);
		Materia materia = getMateria(strMateria);
		try {
			materia.rimuoviProfessore(this);
		}
		catch (ProfessoreNonTrovatoException e) {
			
		}
	}	
	
	public Materia getMateria(String materia) {
		if (!insegna(materia)) {
			throw new MateriaNonTrovataException("la materia " + materia + " non risulta tra quelle insegnate dal profossore: " + this.toString()); 
		}
		return (Materia)_materie.get(materia);
	}
	
	public void aggiungiMateria(Materia materia) {
		if (materia==null) {
			throw new InvalidParameterException("attenzione la materia non pu essere null");
		}
		if (insegna(materia)) {
			throw new MateriaDuplicataException("la materia " + materia + "  gi tra quelle insegnate dal profossore: " + this.toString()); 
		}
		_materie.put(materia.getNome(),materia);
		
		try {
			materia.aggiungiProfessore(this);
		}
		catch (ProfessoreDuplicatoException e) {
			
		}
	}
	
	public Enumeration getMaterie() {
		return _materie.elements();
	}
	
	public Iterator getClassi() {
		return _classi.iterator();
	}
	
	public int numeroDiMaterie() {
		return _materie.size();
	}
}
