/*
 * Created on 14-giu-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package scuola;

import java.security.InvalidParameterException;
import java.util.*;

import scuola.Exceptions.*;

/**
 * @author luigi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Sezione {
	
	private Hashtable _classi;
	private String _descrizione;
	private String _sezione;
	
	//  TOOD costruttore internal?
	public Sezione (String sezione, String descrizione) {
		_classi = new Hashtable();
		_sezione = sezione;
		_descrizione = descrizione;
	}
	
	public void setDescrizione(String descrizione) {
		_descrizione = descrizione;
	}
	
	public String getDescrizione() {
		return _descrizione;
	}
	
	public String getSezione() {
		return _sezione;
	}
	
	public String toString() {
		return "Sezione " + _sezione;
	}
		
	public boolean contieneClasse(Classe classe) {
		if (classe==null) {
			throw new InvalidParameterException("il parametro calsse nono pu essere nullo");
		}
		Integer iAnno = new Integer(classe.getAnno());
		return (_classi.containsKey(iAnno) && classe.getSezione() == this);
	}
	
	public boolean contieneClasse(int anno) {
		Integer iAnno = new Integer(anno);
		return _classi.containsKey(iAnno);
	}
	
	public void aggiungiClasse(Classe classe) {
		if (contieneClasse(classe)) {
			throw new ClasseDuplicataException("esiste gi la classe " + classe.toString() + " nella sezione " + this.toString());
		}
		classe.setSezione(this);
		Integer iAnno = new Integer(classe.getAnno());
		_classi.put(iAnno, classe);
	}
	
	public void rimuoviClasse(Classe classe) {
		if (!contieneClasse(classe)) {
			throw new ClasseNonTrovataException("impossibile trovare la classe " + classe.toString() + " nella sezione " + this.toString());
		}
		if (classe.numeroDiStudenti()!=0) {
			throw new OperazioneNonConsentitaException("impossibile eliminare la classe " + classe.toString() + " poich contiene " + classe.numeroDiStudenti() + " studenti iscritti");
		}
		Integer iAnno = new Integer(classe.getAnno());
		classe.setSezione(null);
		_classi.remove(iAnno);
	}
	
	public void rimuoviClasse(int anno) {
		Classe classe = getClasse(anno);
		rimuoviClasse(classe);
	}
	
	public Classe getClasse(int anno) {
		if (!contieneClasse(anno)) {
			throw new ClasseNonTrovataException("impossibile trovare la classe " + anno + " nella sezione " + this.toString());
		}
		Integer iAnno = new Integer(anno);
		return (Classe)_classi.get(iAnno);
	}
	
	public int numeroDiClassi() {
		return _classi.size();
	}
	
	public Enumeration getClassi() {
		return _classi.elements();
	}
}
